package es.ucm.fdi.grasia.faerie.demos.talkingAgents.out;

import com.sun.speech.freetts.Voice;
import com.sun.speech.freetts.VoiceManager;
import es.ucm.fdi.grasia.faerie.core.Attribute;
import es.ucm.fdi.grasia.faerie.core.Behavior;
import es.ucm.fdi.grasia.faerie.core.ContextEvent;
import es.ucm.fdi.grasia.faerie.core.Entity;
import org.apache.log4j.Logger;

/**
 *
 * @author Chema
 */
public class Talk implements Behavior {

	private String oracle;
	private String voice;

	public Talk(String oracle, String voice) {
		this.oracle = oracle;
		this.voice = voice;
	}

	@Override
	public void run(ContextEvent event) {
		Attribute attribute = event.getSourceAttributeInstance();
		Entity entity = attribute.getEntity();
		Logger.getLogger(this.getClass()).info("<BEHAVIOR> " + oracle + " talking to " + entity.getName());

		VoiceManager voiceManager = VoiceManager.getInstance();
		Voice helloVoice = voiceManager.getVoice(voice);

		helloVoice.allocate();

		String text;
		if ("First Oracle".equals(oracle))
			text = "How you dare to disturb me?";
		else if ("Second Oracle".equals(oracle))
			text = "You are not interesting for me";
		else if ("Third Oracle".equals(oracle))
			text = "You are insignificant";
		else
			text = "Stupid";

		helloVoice.speak("I'm the " + oracle + ". " + text + ", mortal.");
		helloVoice.deallocate();
	}
}