package es.ucm.fdi.grasia.faerie.demos.talkingAgents.out;

import es.ucm.fdi.grasia.faerie.core.AbstractContextObserverComponent;
import es.ucm.fdi.grasia.faerie.core.Attribute;
import es.ucm.fdi.grasia.faerie.core.Behavior;
import es.ucm.fdi.grasia.faerie.core.ContextEvent;
import es.ucm.fdi.grasia.faerie.core.ContextObserver;
import es.ucm.fdi.grasia.faerie.core.ContextValue;
import es.ucm.fdi.grasia.faerie.core.util.Functions;
import es.ucm.fdi.grasia.faerie.demos.talkingAgents.model.MyLocation;
import org.apache.felix.scr.annotations.Component;

/**
 *
 * @author Chema
 */
@Component(inherit = true)
public class TalkingAgentsOutput extends AbstractContextObserverComponent {

	private String previousLocation = null;

	@Override
	public int handle(ContextEvent event) {
		return Functions.contextElementAll(MyLocation.class, event) ? ContextObserver.HANDLE_READ : ContextObserver.HANDLE_NONE;
	}

	@Override
	public void doActivate() {
		this.putBehavior("ENTRANDO_1_HABITACION", new GiveWelcome("First Oracle", "kevin16"));
		this.putBehavior("FRENTE_1_HABITACION", new Talk("First Oracle", "kevin16"));
		this.putBehavior("SALIENDO_1_HABITACION", new SayGoodbye("First Oracle", "kevin16"));

		this.putBehavior("ENTRANDO_2_HABITACION", new GiveWelcome("Second Oracle", "kevin"));
		this.putBehavior("FRENTE_2_HABITACION", new Talk("Second Oracle", "kevin"));
		this.putBehavior("SALIENDO_2_HABITACION", new SayGoodbye("Second Oracle", "kevin"));

		this.putBehavior("ENTRANDO_3_HABITACION", new GiveWelcome("Third Oracle", "kevin16"));
		this.putBehavior("FRENTE_3_HABITACION", new Talk("Third Oracle", "kevin16"));
		this.putBehavior("SALIENDO_3_HABITACION", new SayGoodbye("Third Oracle", "kevin16"));
	}

	@Override
	public void elementAdded(Attribute attributeInstance, ContextEvent event) {
		this.putObservedElement(attributeInstance);
	}

	@Override
	public void elementUpdated(Attribute attributeInstance, ContextEvent event) {
		MyLocation locationAttr = (MyLocation) attributeInstance;
		ContextValue<String> locationValue = locationAttr.getValue();
		String location = (locationValue != null) ? locationValue.getData() : null;

		if (location != null && !location.equals(previousLocation)) {
			previousLocation = location;

			Behavior behavior = this.getBehavior(event);

			if (behavior != null)
				behavior.run(event);
		}
	}
}
